"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ControlledWOQLTable = void 0;

var _react = _interopRequireWildcard(require("react"));

var _ControlledQuery = require("./ControlledQuery");

var _WOQLTable = require("./WOQLTable");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var ControlledWOQLTable = function ControlledWOQLTable(_ref) {
  var client = _ref.client,
      query = _ref.query,
      results = _ref.results,
      order = _ref.order,
      rows = _ref.rows,
      freewidth = _ref.freewidth,
      view = _ref.view,
      onEmpty = _ref.onEmpty,
      onError = _ref.onError,
      onLoading = _ref.onLoading;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      loaded = _useState2[0],
      setLoaded = _useState2[1];

  var _ControlledQueryHook = (0, _ControlledQuery.ControlledQueryHook)(client, query, results, rows, order),
      updateQuery = _ControlledQueryHook.updateQuery,
      changeOrder = _ControlledQueryHook.changeOrder,
      changeLimits = _ControlledQueryHook.changeLimits,
      woql = _ControlledQueryHook.woql,
      result = _ControlledQueryHook.result,
      limit = _ControlledQueryHook.limit,
      start = _ControlledQueryHook.start,
      orderBy = _ControlledQueryHook.orderBy,
      loading = _ControlledQueryHook.loading,
      rowCount = _ControlledQueryHook.rowCount,
      onRefresh = _ControlledQueryHook.onRefresh;

  (0, _react.useEffect)(function () {
    if (query && woql) {
      if (loaded) {
        updateQuery(query);
      } else {
        setLoaded(true);
      }
    }
  }, [query]);

  function isEmpty(res) {
    if (start == 0 && res.rows == 0) return true;
    return false;
  }

  if (result && view && view.prefixes) result.prefixes = view.prefixes;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__loading__parent"
  }, loading && onLoading && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, onLoading()), result && result.status != 200 && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, onError(result)), result && result.status == 200 && isEmpty(result) && onEmpty && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, onEmpty(result)), result && result.status == 200 && !isEmpty(result) && /*#__PURE__*/_react["default"].createElement(_WOQLTable.WOQLTable, {
    result: result,
    freewidth: freewidth,
    view: view ? view.json() : {},
    limit: limit,
    query: woql,
    start: start,
    orderBy: orderBy,
    setLimits: changeLimits,
    setOrder: changeOrder,
    totalRows: rowCount,
    onRefresh: onRefresh
  }));
};

exports.ControlledWOQLTable = ControlledWOQLTable;